<?php

namespace Luticate\Auth\Business;

use Luticate\Utils\LuBusiness;
use Luticate\Auth\DataAccess\LuticatePermissionsUsersDataAccess;
use Luticate\Auth\DBO\LuticatePermissionsUsersDbo;

class LuticatePermissionsUsersBusiness extends LuBusiness {
    protected static function getDataAccess()
    {
        return new LuticatePermissionsUsersDataAccess();
    }

    public static function add($user_id, $permission_name, $permission_value)
    {
        LuticateUsersBusiness::checkUserId($user_id);
        LuticatePermissionsBusiness::checkPermissionName($permission_name);
        $perm = LuticatePermissionsUsersDataAccess::getByName($user_id, $permission_name);
        if (is_null($perm)) {
            $perm = new LuticatePermissionsUsersDbo();
            $perm->setName($permission_name);
            $perm->setValue($permission_value);
            $perm->setUserId($user_id);
            LuticatePermissionsUsersDataAccess::add($perm);
            return true;
        }
        self::badInput("User permission already exists");
        return false;
    }

    public static function del($user_id, $permission_name)
    {
        LuticateUsersBusiness::checkUserId($user_id);
        LuticatePermissionsBusiness::checkPermissionName($permission_name);
        LuticatePermissionsUsersDataAccess::delete($user_id, $permission_name);
        return true;
    }

    public static function edit($user_id, $permission_name, $permission_value)
    {
        LuticateUsersBusiness::checkUserId($user_id);
        LuticatePermissionsBusiness::checkPermissionName($permission_name);
        $perm = LuticatePermissionsUsersDataAccess::getByName($user_id, $permission_name);
        if (!is_null($perm)) {
            LuticatePermissionsUsersDataAccess::edit($user_id, $permission_name, $permission_value);
            return true;
        }
        self::badInput("Permission not found");
        return false;
    }
}